//package com.mh.user.netty;
//
//import com.mh.user.entity.DeviceManageEntity;
//import com.mh.user.service.DeviceManageService;
//import com.mh.user.utils.AnalysisReceiveOrder485;
//import com.mh.user.utils.ExchangeStringUtil;
//import com.mh.user.utils.GetReadOrder485;
//import com.mh.user.utils.SpringBeanUtil;
//import io.netty.buffer.ByteBuf;
//import io.netty.channel.Channel;
//import io.netty.channel.ChannelHandlerAdapter;
//import io.netty.channel.ChannelHandlerContext;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.context.ApplicationContext;
//
//import java.text.SimpleDateFormat;
//import java.util.Date;
//import java.util.List;
//
///**
// * @author ljf
// * @title ：
// * @description ：客户端异步消息处理机制
// * @updateTime 2020-05-13
// * @throws ：
// */
//@Slf4j
//public class NettyMeterClientHandler extends ChannelHandlerAdapter {
//
//    private static int num = 0;
//    private static int size = 0;
//    private static String receiveStr = "";
//    private static String IP = "";
//    List<DeviceManageEntity> deviceManageEntityList;
//
//    // 调用service
//    ApplicationContext context = SpringBeanUtil.getApplicationContext();
//    DeviceManageService deviceManageService = context.getBean(DeviceManageService.class);
//
//    AnalysisReceiveOrder485 analysisReceiveOrder485;
//
//    //    到处理IO事件，异常抛出时调用，已丢弃
//    @Override
//    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
//        Channel incoming = ctx.channel();
//        if (!incoming.isActive()){
//            log.info("通信异常！！");
//            receiveStr = "";
//            log.info("SimpleClient: " + incoming.remoteAddress() + "异常");
//            cause.printStackTrace();
//            ctx.close();
//        }
//    }
//
//    @Override
//    public void channelActive(ChannelHandlerContext ctx) throws Exception {
//        SimpleDateFormat sdf1=new SimpleDateFormat("yyyy-mm-dd HH:mm:ss");
//        Date date=new Date();
//        log.info(sdf1.format(date) + "链接服务端成功！");
//    }
//
//    private ByteBuf getByteBuf(ChannelHandlerContext ctx, String sendStr) {
//        // byte类型的数据
////        byte[] bytes = "这里是将要写往服务端的数据".getBytes(Charset.forName("utf-8"));
////        String sendStr = "5803004900021914";          // 冷量计
//        // 申请一个数据结构存储信息
//        ByteBuf buffer = ctx.alloc().buffer();
//        // 将信息放入数据结构中
//        buffer.writeBytes(ExchangeStringUtil.hexStrToBinaryStr(sendStr));//对接需要16进制
//        return buffer;
//    }
//
//    @Override
//    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
//        Thread.sleep(500);
//        ctx.close();
//        log.info("退出链接！！");
//    }
//
//    @Override
//    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
////        ByteBuf buf = (ByteBuf)msg;
////        byte[] req = new byte[buf.readableBytes()];
////        buf.readBytes(req);
////        String body = new String(req, "UTF-8");
//        ByteBuf buf = (ByteBuf)msg;
//        byte [] bytes = new byte[buf.readableBytes()];
//        buf.readBytes(bytes);//复制内容到字节数组bytes
//        receiveStr = receiveStr + ExchangeStringUtil.bytesToHexString(bytes);//将接收到的数据转为字符串，此字符串就是客户端发送的字符串
//        log.info("接受服务器数据：" + receiveStr + "，大小： " + receiveStr.length());
//    }
//
//    @Override
//    public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {
//        log.info("数据读取接收完成");
//        if (receiveStr.contains("c0a801f0")) {   // 电表
//
//            // 生成对应的采集指令
//            deviceManageEntityList = deviceManageService.queryDevicesByType("1");
//            size = deviceManageEntityList.size();
//
//            log.info("初始连接报文： " + receiveStr);
//            IP = receiveStr;
//            receiveStr = "";
//            num = 0;
//            // 1.创建将要写出的数据
////            String sendStr = "6830043080000068110432326536C816";            // 网络单相电表
////            String sendStr = "FEFEFEFE6880025007000068010243C3B216";  // 广仪三相电表
//            String collectionNum = deviceManageEntityList.get(num).getCollectionNum();
//            String sendStr = GetReadOrder485.createMeterOrder(collectionNum,"1");
//            ByteBuf buffer = getByteBuf(ctx,sendStr);
//            // 2.发送数据
//            ctx.channel().writeAndFlush(buffer);
//        } else if ((receiveStr.length() == 44) && (IP.contains("c0a801f0"))) {
//            analysisReceiveOrder485.analysisMeterOrder485(receiveStr);          // 解析电表
//            receiveStr = "";
//            num = num + 1;
//            Thread.sleep(1000);
//            if (num >= size-1) {
//                num = 0;
//                // 关闭连接
//                ctx.close();
//            } else {
//                // 1.创建将要写出的数据
//                //            fe fe fe fe 68 80 02 50 07 00 00 68 81 06 43 c3 8c 34 33 33 5c 16
////            String sendStr = "FEFEFE6880025007000068010243C3B216";
//                String collectionNum = deviceManageEntityList.get(num).getCollectionNum();
//                String sendStr = GetReadOrder485.createMeterOrder(collectionNum, "1");
//                ByteBuf buffer = getByteBuf(ctx, sendStr);
//                // 2.发送数据
//                ctx.channel().writeAndFlush(buffer);
//                log.info("客户端再次往服务端发送数据" + num);
//            }
//        } else if ((receiveStr.length() > 44)) {
//            log.info(receiveStr);
//            receiveStr = "";
//            ctx.flush();
//            ctx.close();
//        }
//        ctx.flush();
//    }
//
//}
